/*
 * This turns your Arduino into a Data AcQuisition device at 33S/s.
 *
 * Install this, then run the analog_shield_grid Processing sketch
 * on your PC to test your kit.
 *
 * This is also the recommended thing to run for most PC interfacing.
 *
 * To run custom code on the Arduino itself, use this as a template.
 */


#include <util/delay.h>

void setup() {
  pinMode(2, OUTPUT);
  pinMode(3, OUTPUT);
  pinMode(4, OUTPUT);

  Serial.begin(115200);
}

void loop() {
  
  while(1) {
    int vals[48];
    int i;

    int t0 = millis();

  for(i = 7; i >= 0; i--) {
    digitalWrite(4, i&4);
    digitalWrite(3, i&2);
    digitalWrite(2, i&1);


    for(int j = 0; j < 6; j++) {
      int x = analogRead(j);
      vals[8*i + j] = x;

      Serial.print(x);

      // You may want to test your row/column decoding:
      // Serial.print(j * 255/6); // which mux is which
      // Serial.print(i * 255/8); // which row is which
      Serial.print(' ');
    }
  }
  
  Serial.println();

  int t1 = millis();
  if (t1-t0 < 33) delay(33-(t1-t0));

  }
}  
